/*
 * $Id: load.c,v 1.4 2000/09/07 07:10:06 keithp Exp $
 *
 * Copyright  2000 Keith Packard
 *
 * Permission to use, copy, modify, distribute, and sell this software and its
 * documentation for any purpose is hereby granted without fee, provided that
 * the above copyright notice appear in all copies and that both that
 * copyright notice and this permission notice appear in supporting
 * documentation, and that the name of Keith Packard not be used in
 * advertising or publicity pertaining to distribution of the software without
 * specific, written prior permission.  Keith Packard makes no
 * representations about the suitability of this software for any purpose.  It
 * is provided "as is" without express or implied warranty.
 *
 * KEITH PACKARD DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE,
 * INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS, IN NO
 * EVENT SHALL KEITH PACKARD BE LIABLE FOR ANY SPECIAL, INDIRECT OR
 * CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE,
 * DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER
 * TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
 * PERFORMANCE OF THIS SOFTWARE.
 */

#include "formula.h"

FormInt
FormLoad (FormPickle	*p,
	  FormExe	*e)
{
    FormByte	*storage;

    if (p->version != FormulaOpVersion)
	return -1;
    
    storage = (FormByte *) (p + 1);
    
    e->numConst = p->numConst;
    e->consts = (void *) storage;
    storage = storage + p->numConst * sizeof (FormNumber);
    
    e->numGlobal = p->numGlobal;
    e->globals = (void *) storage;
    storage = storage + p->numGlobal * sizeof (FormInt);

    e->numVar = p->numVar;
    e->vars = (void *) storage;
    storage = storage + p->numVar * sizeof (FormVar);

    e->numFunc = p->numFunc;
    e->funcs = (void *) storage;
    storage = storage + p->numFunc * sizeof (FormFunc);

    e->code = (void *) storage;
    storage = storage + p->codeSize;

    e->strings = (void *) storage;
    storage = storage + p->stringSize;

    e->name = p->name - (e->strings - (FormByte *) p);
    return 0;
}

