/*
 * $Id: prim.c,v 1.5 2000/09/07 07:10:06 keithp Exp $
 *
 * Copyright  2000 Keith Packard
 *
 * Permission to use, copy, modify, distribute, and sell this software and its
 * documentation for any purpose is hereby granted without fee, provided that
 * the above copyright notice appear in all copies and that both that
 * copyright notice and this permission notice appear in supporting
 * documentation, and that the name of Keith Packard not be used in
 * advertising or publicity pertaining to distribution of the software without
 * specific, written prior permission.  Keith Packard makes no
 * representations about the suitability of this software for any purpose.  It
 * is provided "as is" without express or implied warranty.
 *
 * KEITH PACKARD DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE,
 * INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS, IN NO
 * EVENT SHALL KEITH PACKARD BE LIABLE FOR ANY SPECIAL, INDIRECT OR
 * CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE,
 * DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER
 * TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
 * PERFORMANCE OF THIS SOFTWARE.
 */

#include    "formula.h"
#include    <MathLib.h>

FormNumber
FormPow (FormNumber a, FormNumber b)
{
    FormNumber	result;
    FormNumber	p;
    long	i;
    FormInt    	flip = 0;

    i = (long) b;
    if ((FormNumber) i == b)
    {
	if (i < 0)
	{
	    i = -i;
	    flip = 1;
	}
	p = a;
	result = NumberOne;
	while (i) {
	    if (i & 1)
		result = result * p;
	    i >>= 1;
	    if (i)
		p = p * p;
	}
	if (flip)
	    result = NumberOne / result;
    }
    else
    {
	result = exp (b * log (a));
    }
    return result;
}

