#include    "formula.h"

FormMachine machine;

void
runFunc (FormMachine *m, FormInt func)
{
    FormFunc	*f;
    int		i;
    FormInt	var;
    FormVar	*v;
    FormNumber	n;

    for (i = 0; i < m->exe.numGlobal; i++)
	m->globals[i] = ExeConst (&m->exe, ExeGlobal(&m->exe,i));
    
    f = &m->exe.funcs[func];
#ifdef UNIX
    printf ("Running function %s\n", ExeString (&m->exe, f->name));
#endif
    m->pc = f->codeBlock;
    m->rp = RET_STACK;
    m->fp = VALUE_STACK - f->numParam;
    m->sp = m->fp - (f->numResult + f->numLocal);
    var = f->vars + f->numResult;
    for (i = 0; i < f->numParam; i++)
    {
	v = ExeVar (&m->exe, var + i);
#ifdef UNIX
	printf ("parameter %s: ",
		v->label == -1 ? ExeString (&m->exe, v->name) :
		ExeString (&m->exe, v->label));
	scanf ("%lg", &n);
#endif
	MachStore (m, var + i, n);
    }
    MachRun (m);
    if (m->state == FormSuccess)
    {
	var = f->vars;
	for (i = 0; i < f->numResult; i++)
	{
	    v = ExeVar (&m->exe, var + i);
#ifdef UNIX
	    printf ("result %s: %g\n",
		    v->label == -1 ? ExeString (&m->exe, v->name) :
		    ExeString (&m->exe, v->label),
		    MachFetch (m, var + i));
#endif
	}
    }
}

int
main (int argc, char **argv)
{
    int		i;
    FormPickle	*p;
    
    p = FormParse ();
    if (p)
    {
	FormLoad (p, &machine.exe);
	if (machine.exe.name != -1)
	{
#ifdef UNIX
	    printf ("Parsed %s\n", ExeString (&machine.exe, machine.exe.name));
#endif
	}
	for (i = 0; i < machine.exe.numFunc; i++)
	{
	    if (machine.exe.funcs[i].label != -2)
		runFunc (&machine, i);
	}
    }
    return 0;
}
